import java.util.Calendar;
import java.util.Hashtable;
import java.util.Vector;

import quadbase.reportdesigner.util.IExportConstants;
import quadbase.scheduler.ScheduleModifier;
import quadbase.scheduler.ScheduleObject;

//Run this example from Report Designer install directory
//Report manager must be running
public class SchedulingExportParamReportEmail {
	public static void main(String[] args) {
		SchedulingExportParamReportEmail doScheduleExport = new SchedulingExportParamReportEmail();
		try {
			doScheduleExport.createScheduleObject();
		} catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}

	void createScheduleObject() throws Exception {
		ScheduleModifier.setServerAddress("127.0.0.1");
		ScheduleModifier.setServerPortNumber(22071);

		ScheduleObject sObj = new ScheduleObject("ParamReport_Email", ScheduleObject.REPORTOBJ);
		//		Single Param Report
		sObj.setFileLocation("EmployeeDetails.pak");
		String exportLoc = sObj.pickDefaultExportLocation();
		sObj.setReportType(IExportConstants.DHTML);
		sObj.setTaskOption(ScheduleObject.ONE_TIME);
		//		1st param set {"Denise Carron"}
		Object tmp1[] = { "Denise Carron" };
		//		2nd param set {"Frank Carnody"}
		Object tmp2[] = { "Frank Carnody" };
		Vector paramList = new Vector();
		paramList.addElement(tmp1);
		paramList.addElement(tmp2);
		sObj.setParamList(paramList);
		Vector paramNameList = new Vector();
		paramNameList.addElement("Denise");
		paramNameList.addElement("Frank");
		sObj.setParamList(paramNameList, paramList);
		Calendar calendar = Calendar.getInstance();
		calendar.add(Calendar.MINUTE, 5);
		sObj.setStartDate(calendar.getTimeInMillis());
		sObj.setSendEmail(true);
		sObj.setFromAddress("user1@quadbase.com");
		sObj.setSubject("Param Report Email Account Report");
		sObj.setBodyText("Scheduled Export of Employee Details from user1");
		sObj.setEmailType(ScheduleObject.ASATTACHMENT);
		Hashtable toAddr = new Hashtable();
		toAddr.put("Denise", new String[] { "user2@quadbase.com" });
		toAddr.put("Frank", new String[] { "user3@quadbase.com" });
		sObj.setParamAddresses(toAddr);

		ScheduleModifier.addScheduleTask(sObj);
	}

}
